Index: channels/chan_agent.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_agent.c,v
retrieving revision 1.137
diff -u -r1.137 chan_agent.c
--- channels/chan_agent.c	6 Jun 2005 22:12:18 -0000	1.137
+++ channels/chan_agent.c	7 Jun 2005 12:55:07 -0000
@@ -13,12 +13,13 @@
 
 #include <stdio.h>
 #include <string.h>
-#include <sys/socket.h>
 #include <errno.h>
 #include <unistd.h>
+#include <sys/socket.h>
 #include <stdlib.h>
 #include <fcntl.h>
 #include <netdb.h>
+#include <netinet/in.h>
 #include <arpa/inet.h>
 #include <sys/signal.h>
 
Index: channels/chan_features.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_features.c,v
retrieving revision 1.13
diff -u -r1.13 chan_features.c
--- channels/chan_features.c	6 Jun 2005 22:12:19 -0000	1.13
+++ channels/chan_features.c	7 Jun 2005 12:55:07 -0000
@@ -13,12 +13,13 @@
 
 #include <stdio.h>
 #include <string.h>
+#include <unistd.h>
 #include <sys/socket.h>
 #include <errno.h>
-#include <unistd.h>
 #include <stdlib.h>
 #include <fcntl.h>
 #include <netdb.h>
+#include <netinet/in.h>
 #include <arpa/inet.h>
 #include <sys/signal.h>
 
Index: channels/chan_local.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_local.c,v
retrieving revision 1.48
diff -u -r1.48 chan_local.c
--- channels/chan_local.c	6 Jun 2005 22:12:19 -0000	1.48
+++ channels/chan_local.c	7 Jun 2005 12:55:08 -0000
@@ -13,12 +13,13 @@
 
 #include <stdio.h>
 #include <string.h>
+#include <unistd.h>
 #include <sys/socket.h>
 #include <errno.h>
-#include <unistd.h>
 #include <stdlib.h>
 #include <fcntl.h>
 #include <netdb.h>
+#include <netinet/in.h>
 #include <arpa/inet.h>
 #include <sys/signal.h>
 
Index: channels/chan_mgcp.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_mgcp.c,v
retrieving revision 1.124
diff -u -r1.124 chan_mgcp.c
--- channels/chan_mgcp.c	6 Jun 2005 22:12:19 -0000	1.124
+++ channels/chan_mgcp.c	7 Jun 2005 12:55:12 -0000
@@ -55,19 +55,20 @@
 
 #include <stdio.h>
 #include <string.h>
+#include <unistd.h>
 #include <sys/socket.h>
 #include <sys/ioctl.h>
 #include <net/if.h>
 #include <errno.h>
-#include <unistd.h>
 #include <stdlib.h>
 #include <fcntl.h>
 #include <netdb.h>
-#include <arpa/inet.h>
 #include <sys/signal.h>
 #include <signal.h>
+#include <netinet/in.h>
 #include <netinet/in_systm.h>
 #include <netinet/ip.h>
+#include <arpa/inet.h>
 #include <ctype.h>
 
 #include "asterisk.h"
Index: channels/chan_modem.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_modem.c,v
retrieving revision 1.41
diff -u -r1.41 chan_modem.c
--- channels/chan_modem.c	6 Jun 2005 22:12:19 -0000	1.41
+++ channels/chan_modem.c	7 Jun 2005 12:55:13 -0000
@@ -13,18 +13,18 @@
 
 #include <stdio.h>
 #include <string.h>
+#include <ctype.h>
+#include <stdlib.h>
+#include <unistd.h>
 #include <sys/socket.h>
 #include <sys/time.h>
 #include <errno.h>
-#include <unistd.h>
-#include <stdlib.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <fcntl.h>
 #include <sys/ioctl.h>
 #include <sys/termios.h>
 #include <sys/signal.h>
-#include <ctype.h>
 
 #include "asterisk.h"
 
Index: channels/chan_sip.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_sip.c,v
retrieving revision 1.755
diff -u -r1.755 chan_sip.c
--- channels/chan_sip.c	6 Jun 2005 22:12:19 -0000	1.755
+++ channels/chan_sip.c	7 Jun 2005 12:55:25 -0000
@@ -15,18 +15,19 @@
 #include <stdio.h>
 #include <ctype.h>
 #include <string.h>
+#include <unistd.h>
 #include <sys/socket.h>
 #include <sys/ioctl.h>
 #include <net/if.h>
 #include <errno.h>
-#include <unistd.h>
 #include <stdlib.h>
 #include <fcntl.h>
 #include <netdb.h>
-#include <arpa/inet.h>
 #include <signal.h>
 #include <sys/signal.h>
+#include <netinet/in.h>
 #include <netinet/in_systm.h>
+#include <arpa/inet.h>
 #include <netinet/ip.h>
 #include <regex.h>
 
Index: channels/chan_skinny.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_skinny.c,v
retrieving revision 1.79
diff -u -r1.79 chan_skinny.c
--- channels/chan_skinny.c	6 Jun 2005 22:12:19 -0000	1.79
+++ channels/chan_skinny.c	7 Jun 2005 12:55:28 -0000
@@ -16,13 +16,13 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <unistd.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <netinet/tcp.h>
 #include <sys/ioctl.h>
 #include <net/if.h>
 #include <errno.h>
-#include <unistd.h>
 #include <fcntl.h>
 #include <netdb.h>
 #include <arpa/inet.h>
Index: formats/format_g723.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_g723.c,v
retrieving revision 1.19
diff -u -r1.19 format_g723.c
--- formats/format_g723.c	6 Jun 2005 22:12:19 -0000	1.19
+++ formats/format_g723.c	7 Jun 2005 12:55:32 -0000
@@ -11,10 +11,11 @@
  * the GNU General Public License
  */
  
+#include <unistd.h>
+#include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdlib.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <errno.h>
 #include <string.h>
 #include <sys/time.h>
Index: formats/format_g726.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_g726.c,v
retrieving revision 1.10
diff -u -r1.10 format_g726.c
--- formats/format_g726.c	6 Jun 2005 22:12:19 -0000	1.10
+++ formats/format_g726.c	7 Jun 2005 12:55:32 -0000
@@ -9,12 +9,12 @@
  * the GNU General Public License
  */
  
+#include <unistd.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdlib.h>
 #include <sys/time.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <errno.h>
 #include <string.h>
 
Index: formats/format_g729.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_g729.c,v
retrieving revision 1.19
diff -u -r1.19 format_g729.c
--- formats/format_g729.c	6 Jun 2005 22:12:19 -0000	1.19
+++ formats/format_g729.c	7 Jun 2005 12:55:33 -0000
@@ -11,12 +11,12 @@
  * the GNU General Public License
  */
  
+#include <unistd.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdlib.h>
 #include <sys/time.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <errno.h>
 #include <string.h>
 
Index: formats/format_gsm.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_gsm.c,v
retrieving revision 1.24
diff -u -r1.24 format_gsm.c
--- formats/format_gsm.c	6 Jun 2005 22:12:19 -0000	1.24
+++ formats/format_gsm.c	7 Jun 2005 12:55:33 -0000
@@ -11,12 +11,12 @@
  * the GNU General Public License
  */
  
+#include <unistd.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdlib.h>
 #include <sys/time.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <errno.h>
 #include <string.h>
 
Index: formats/format_h263.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_h263.c,v
retrieving revision 1.11
diff -u -r1.11 format_h263.c
--- formats/format_h263.c	6 Jun 2005 22:12:19 -0000	1.11
+++ formats/format_h263.c	7 Jun 2005 12:55:33 -0000
@@ -11,12 +11,12 @@
  * the GNU General Public License
  */
  
+#include <unistd.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdlib.h>
 #include <sys/time.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <errno.h>
 #include <string.h>
 
Index: formats/format_ilbc.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_ilbc.c,v
retrieving revision 1.12
diff -u -r1.12 format_ilbc.c
--- formats/format_ilbc.c	6 Jun 2005 22:12:19 -0000	1.12
+++ formats/format_ilbc.c	7 Jun 2005 12:55:33 -0000
@@ -13,12 +13,12 @@
  * the GNU General Public License
  */
  
+#include <unistd.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdlib.h>
 #include <sys/time.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <errno.h>
 #include <string.h>
 
Index: formats/format_pcm.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_pcm.c,v
retrieving revision 1.20
diff -u -r1.20 format_pcm.c
--- formats/format_pcm.c	6 Jun 2005 22:12:19 -0000	1.20
+++ formats/format_pcm.c	7 Jun 2005 12:55:33 -0000
@@ -11,12 +11,12 @@
  * the GNU General Public License
  */
  
+#include <unistd.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdlib.h>
 #include <sys/time.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <errno.h>
 #include <string.h>
 
Index: formats/format_pcm_alaw.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_pcm_alaw.c,v
retrieving revision 1.18
diff -u -r1.18 format_pcm_alaw.c
--- formats/format_pcm_alaw.c	6 Jun 2005 22:12:19 -0000	1.18
+++ formats/format_pcm_alaw.c	7 Jun 2005 12:55:34 -0000
@@ -11,6 +11,7 @@
  * the GNU General Public License
  */
  
+#include <unistd.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdlib.h>
@@ -18,7 +19,6 @@
 #include <sys/times.h>
 #include <sys/types.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <errno.h>
 #include <string.h>
 
Index: formats/format_sln.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_sln.c,v
retrieving revision 1.8
diff -u -r1.8 format_sln.c
--- formats/format_sln.c	6 Jun 2005 22:12:19 -0000	1.8
+++ formats/format_sln.c	7 Jun 2005 12:55:34 -0000
@@ -9,12 +9,12 @@
  * the GNU General Public License
  */
  
+#include <unistd.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdlib.h>
 #include <sys/time.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <errno.h>
 #include <string.h>
 
Index: formats/format_vox.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_vox.c,v
retrieving revision 1.21
diff -u -r1.21 format_vox.c
--- formats/format_vox.c	6 Jun 2005 22:12:19 -0000	1.21
+++ formats/format_vox.c	7 Jun 2005 12:55:34 -0000
@@ -11,12 +11,12 @@
  * the GNU General Public License
  */
  
+#include <unistd.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdlib.h>
 #include <sys/time.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <errno.h>
 #include <string.h>
 
Index: formats/format_wav.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_wav.c,v
retrieving revision 1.24
diff -u -r1.24 format_wav.c
--- formats/format_wav.c	6 Jun 2005 22:12:19 -0000	1.24
+++ formats/format_wav.c	7 Jun 2005 12:55:34 -0000
@@ -11,12 +11,12 @@
  * the GNU General Public License
  */
  
+#include <unistd.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdlib.h>
 #include <sys/time.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <errno.h>
 #include <string.h>
 
Index: formats/format_wav_gsm.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_wav_gsm.c,v
retrieving revision 1.33
diff -u -r1.33 format_wav_gsm.c
--- formats/format_wav_gsm.c	6 Jun 2005 22:12:19 -0000	1.33
+++ formats/format_wav_gsm.c	7 Jun 2005 12:55:35 -0000
@@ -11,12 +11,12 @@
  * the GNU General Public License
  */
  
+#include <unistd.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 #include <stdlib.h>
 #include <sys/time.h>
 #include <stdio.h>
-#include <unistd.h>
 #include <errno.h>
 #include <string.h>
 
Index: include/asterisk/utils.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/utils.h,v
retrieving revision 1.31
diff -u -r1.31 utils.h
--- include/asterisk/utils.h	20 May 2005 16:30:13 -0000	1.31
+++ include/asterisk/utils.h	7 Jun 2005 12:55:35 -0000
@@ -17,6 +17,7 @@
 #endif
 
 #include <netinet/in.h>
+#include <arpa/inet.h>	/* we want to override inet_ntoa */
 #include <netdb.h>
 #include <pthread.h>
 #include <limits.h>
Index: pbx/pbx_dundi.c
===================================================================
RCS file: /usr/cvsroot/asterisk/pbx/pbx_dundi.c,v
retrieving revision 1.36
diff -u -r1.36 pbx_dundi.c
--- pbx/pbx_dundi.c	6 Jun 2005 22:12:19 -0000	1.36
+++ pbx/pbx_dundi.c	7 Jun 2005 12:55:40 -0000
@@ -11,8 +11,8 @@
 
 #include <stdlib.h>
 #include <unistd.h>
-#include <arpa/inet.h>
 #include <netinet/in.h>
+#include <arpa/inet.h>
 #include <sys/socket.h>
 #include <string.h>
 #include <errno.h>